﻿package
{
	
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.events.Event;
	import cc.cote.airbag.*;

	public class Ball extends Sprite
	{
		
		// Speed vectors for x axis
		public var vx:Number = 0;
		public var vy:Number = 0;
		
		// AirBag
		public var airbag:AirBag;
		
		public function Ball(border:DisplayObject):void {
			
			// Create and configure the detection object
			airbag = new AirBag(this);
			airbag.singleTarget = border;
			airbag.calculateAngles = true;
			airbag.calculateOverlap = true;
			
			// Set initial speed
			vx = getRandomNumberFromRange(2, 5, true);
			vy = getRandomNumberFromRange(2, 5, true);
			
			// Wait for ball to be on stage
			addEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
			
		}
		
		public function onAddedToStage(e:Event):void {
			
			removeEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
			
			// Create visual (gray circle)
			createCircle(0x55555, 10, 0);
			
			// Move the ball
			addEventListener(Event.ENTER_FRAME, move);
		}
		
		public function createCircle(color:uint, size:Number, offset:Number):void {
			var circle:Sprite = new Sprite();
			circle.graphics.beginFill(color, .5);
			circle.graphics.drawCircle(offset, offset, size);
			circle.x = Math.random() * (stage.stageWidth - (size * 8)) + size * 4;
			circle.y = Math.random() * (stage.stageHeight - (size * 8)) + size * 4;
			addChild(circle);
		}
		
		public function move(e:Event):void {
			
			// Detect collision
			var collisions:Vector.<Collision> = airbag.detect();
			
			// If a collision is detected, change speed vectors according to angles
			if (collisions.length) {
				var angle:Number = collisions[0].angle;
				var overlap:int = collisions[0].overlapping.length;
				vx -= Math.cos(angle) * overlap / width;
				vy -= Math.sin(angle) * overlap / height;
			}

			// Move the ball
			x += vx;
			y += vy;
			
		}

		public function getRandomNumberFromRange(min:Number, max:Number, signed:Boolean = false):Number {
			var number:Number = (Math.random() * (max - min) + min);
			if (signed) number = number * (new <int>[-1, 1])[Math.round(Math.random())];
			return number;
		}
		
	}
	
}