﻿package  {
	
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.geom.ColorTransform;
	
	import cc.cote.airbag.*;
	import flash.events.Event;
	import net.hires.debug.Stats;
	import flash.geom.Matrix;
	import flash.utils.getTimer;
	
	public class ManyToManyDemo extends MovieClip 
	{
		
		public var airbag:AirBag;
		public var container:Sprite = new Sprite();
		
		public var count:uint = 0;
		public var t:uint = 0;
		
		public function ManyToManyDemo() {
			
			// Performance stats
			var stats:Stats = new Stats();
			stats.x = stage.stageWidth - 75;
			stats.y = 5;
			addChild(stats);
						
			addChildAt(container, 0);
			
			// Instantiate AirBag object (in this case, we'll add objects as they are created)
			airbag = new AirBag();
			
			// Create a bunch of circles and add them to the container (and to the AirBag 
			// detection list)
			for (var i:uint = 0; i < 35; i++) {
				var circle:Sprite = createCircle(0x055555, Math.random() * 20 + 10, Math.random() * 125 + 25);
				container.addChild(circle);
				
				// The add() method adds the object to the detection list
				airbag.add(circle);
			}
			
			airbag.addEventListener(AirBagEvent.DETECTION, onDetection);
			airbag.start();
			
		}
		
		public function onDetection(e:AirBagEvent):void {
			
			var ct:ColorTransform = new ColorTransform();
			
			// Reset all existing circles' color to gray
			for (var i:uint = 0; i < container.numChildren; i++) {
				ct.color = 0x055555;
				container.getChildAt(i).transform.colorTransform = ct;
			}
			
			// Go through all collisioning objects and color them red
			for each (var collision in e.collisions) {
				ct.color = 0xFF0000;
				collision.objects[0].transform.colorTransform = ct;
				collision.objects[1].transform.colorTransform = ct;
			}
			
		}
		
		public function createCircle(color:uint, size:Number, offset:Number):Sprite {
			var circle:Sprite = new Sprite();
			circle.graphics.beginFill(color, .5);
			circle.graphics.drawCircle(offset, offset, size);
			circle.x = Math.random() * stage.stageWidth;
			circle.y = Math.random() * stage.stageHeight;
			circle.addEventListener(Event.ENTER_FRAME, rotate);
			return circle;
		}
		
		public function rotate(e:Event):void {
			e.currentTarget.rotation += .5;
		}
		
	}
	
}